Ruby - Bug #7514

DL::Function and DL::Importer#bind_function ignores abi and name when Fiddle is available
12/05/2012 11:59 AM - ngoto (Naohisa Goto)
Description

Like Bug #7484, when Fiddle is available, Fiddle's DL wrapper for DL::Function ignores :stdcall ABI. In addition, when creating
callback closure, DL::Function wrapped by Fiddle does not set name, and DL::Function#name raises NoMethodError.

Associated revisions

Revision f1841f43eb9d7ec45bcbee7f70abae77d999176d - 12/05/2012 03:20 AM - ngoto (Naohisa Goto)

ext/dl/lib/dl/func.rb (DL::Function#initialize, DL::Function#bind):

ABI should be set by using CFunc#calltype even when Fiddle is used.
When Fiddle is used and a block is given, name shoud not be ignored.
[ruby-core:50562] [Bug #7514]

ext/dl/lib/dl/import.rb (DL::Importer#bind_function): should respect

abi and name when Fiddle is used.

test/dl/test_func.rb (test_name_with_block): test for "name" method
with giving a block.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@38202 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 1841143 - 12/05/2012 03:20 AM - ngoto (Naohisa Goto)

ext/dl/lib/dl/func.rb (DL::Function#initialize, DL::Function#bind):

ABI should be set by using CFunc#calltype even when Fiddle is used.
When Fiddle is used and a block is given, name shoud not be ignored.
[ruby-core:50562] [Bug #7514]

ext/dl/lib/dl/import.rb (DL::Importer#bind_function): should respect

abi and name when Fiddle is used.

test/dl/test_func.rb (test_name_with_block): test for "name" method
with giving a block.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@38202 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 74bca55da9e509592bd04bc785b6eb86082f8cfe - 12/20/2012 09:52 AM - U.Nakamura
merge revision(s) 38202,38238,38324,38326: [Backport #7527]

e test/dl/test_func.rb (test_name_with_block, test_bind, test_gsort1):
call unbind to release the callback closure because maximum number
of callbacks is limited to DL::MAX_CALLBACK (== 5) with pure DL
without Fiddle.

ext/dl/lib/dl/func.rb (DL::Function#unbind, #bound?): suppress
NoMethodError when Fiddle is available. [ruby-core:50756] [Bug #7543]

test/dl/test_func.rb (test_bound*, test_unbind*): tests for the above.

ext/dl/lib/dl/func.rb (DL::Function#initialize, DL::Function#bind):

ABI should be set by using CFunc#calltype even when Fiddle is used.
When Fiddle is used and a block is given, name shoud not be ignored.
[ruby-core:50562] [Bug #7514]

ext/dl/lib/dl/import.rb (DL::Importer#bind_function): should respect
abi and name when Fiddle is used.

test/dl/test_func.rb (test_name_with_block): test for "name" method
with giving a block.
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9 3@38506 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 74bca55d - 12/20/2012 09:52 AM - U.Nakamura
merge revision(s) 38202,38238,38324,38326: [Backport #7527]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9 3@38506 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

test/dl/test_func.rb (test_name_with_block, test_bind, test_gsort1):
call unbind to release the callback closure because maximum number
of callbacks is limited to DL::MAX_CALLBACK (== 5) with pure DL
without Fiddle.

ext/dl/lib/dl/func.rb (DL::Function#unbind, #bound?): suppress
NoMethodError when Fiddle is available. [ruby-core:50756] [Bug #7543]

test/dl/test_func.rb (test_bound*, test_unbind*): tests for the above.

ext/dl/lib/dl/func.rb (DL::Function#initialize, DL::Function#bind):

ABI should be set by using CFunc#calltype even when Fiddle is used.
When Fiddle is used and a block is given, name shoud not be ignored.
[ruby-core:50562] [Bug #7514]

ext/dl/lib/dl/import.rb (DL::Importer#bind_function): should respect
abi and name when Fiddle is used.

test/dl/test_func.rb (test_name_with_block): test for "name" method
with giving a block.

History

#1 - 12/05/2012 12:20 PM - ngoto (Naohisa Goto)

- Status changed from Open to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r38202.
Naohisa, thank you for reporting this issue.
Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

o ext/dl/lib/dl/func.rb (DL::Function#initialize, DL::Function#bind):

ABI should be set by using CFunc#calltype even when Fiddle is used.
When Fiddle is used and a block is given, name shoud not be ignored.
[ruby-core:50562] [Bug #7514]

ext/dl/lib/dl/import.rb (DL::Importer#bind_function): should respect

abi and name when Fiddle is used.

test/dl/test_func.rb (test_name_with_block): test for "name" method
with giving a block.

#2 - 12/05/2012 06:17 PM - usa (Usaku NAKAMURA)

- Category set to ext

- Status changed from Closed to Assigned

- Assignee set to ngoto (Naohisa Goto)

- Target version set to 2.0.0

Hmm, when using DL::Function, the patch solves the problem.

But, when we try to shift to Fiddle from DL, since Fiddle::Function

does not still have name.

So we can not shift simply.

| think that better solution of this problem is not deceiving DL::Function,
but adding name to Fiddle::Function perfectly.

Goto-san, Aaron, how do you think about this?

In addition, | am actually afflicted by this shift problem now, and this
problem is serious for me.
#3 - 12/07/2012 02:02 AM - ngoto (Naohisa Goto)

In the commit r38243, Fiddle::Function#name is added, and Fiddle::Importer#import_function and bind_function set the name. The name attribute
would be used by Fiddle version of Win32::Registry.

#4 - 12/12/2012 12:12 AM - ngoto (Naohisa Goto)
- Status changed from Assigned to Closed

In r388322, Fiddle::Function#initialize can get name by using :name keyword argument. For example,
Fiddle::Function.new(ptr, [], Fiddle: TYPE_VOID, name: "example")
